<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/communication/Message.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_fb7ca0dcf3f8c533686c530ed50d41b5.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Message.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Message_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef MESSAGE_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define MESSAGE_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;types.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE = u<span class="keywordtype">int</span>32&gt;</div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="classMessage.html">   28</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMessage.html">Message</a></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;{</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <a class="code" href="classMessage.html">Message</a>(){}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classMessage.html#a607c353c056c6359ab048b7bdb8ec9ba">   41</a></span>&#160;    <a class="code" href="classMessage.html#a607c353c056c6359ab048b7bdb8ec9ba">Message</a>(ID_TYPE &amp; tx, ID_TYPE &amp; rx, DATA_TYPE &amp; messContent)</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">setMessage</a>(tx, rx, messContent);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;   ~<a class="code" href="classMessage.html">Message</a>(){}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">   49</a></span>&#160;    ID_TYPE  <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a>;</div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">   51</a></span>&#160;    ID_TYPE  <a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a>;</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">   53</a></span>&#160;    DATA_TYPE  <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classMessage.html#ad519d3924cb24505cee555c7893a0faa">   58</a></span>&#160;    <span class="keyword">inline</span> ID_TYPE &amp; <a class="code" href="classMessage.html#ad519d3924cb24505cee555c7893a0faa">getSender</a>()</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classMessage.html#a8d71332a70b8bd5e8e9c43e9cdd0c92f">   65</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> ID_TYPE &amp; <a class="code" href="classMessage.html#a8d71332a70b8bd5e8e9c43e9cdd0c92f">getRcvr</a>()</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classMessage.html#a73f1bc7e19b3afd684897359f37fc67b">   72</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> DATA_TYPE &amp; <a class="code" href="classMessage.html#a73f1bc7e19b3afd684897359f37fc67b">getContent</a>()</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    }</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classMessage.html#a0464788d45c851549e4e483a9cb3723c">   79</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMessage.html#a0464788d45c851549e4e483a9cb3723c">messageSize</a>(){<span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE)+1;}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">   87</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">setMessage</a>(ID_TYPE &amp; tx, ID_TYPE &amp; rx, DATA_TYPE &amp; messContent)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    {</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a> = tx;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a> = rx;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> = messContent;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    }</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment"></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="classMessage.html#a38c93c3a1da92bd20e0a8f166c30b6b7">   98</a></span>&#160;    <span class="keyword">inline</span>  <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a38c93c3a1da92bd20e0a8f166c30b6b7">setMessage</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> = newMessage.getContent();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a> = newMessage.getRcvr();</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a> = newMessage.getSender();</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classMessage.html#af9d795d348683c4b432736e821e76968">  108</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  <span class="keywordtype">void</span> <a class="code" href="classMessage.html#af9d795d348683c4b432736e821e76968">setContent</a>(DATA_TYPE  newContent)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> = newContent;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    }</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classMessage.html#ad81cd4c7117b9a7fc5fad85cb2466cbf">  115</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  <span class="keywordtype">void</span> <a class="code" href="classMessage.html#ad81cd4c7117b9a7fc5fad85cb2466cbf">sumContent</a>(DATA_TYPE  newContent)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> += newContent;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    }</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment"></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">  123</a></span>&#160;    <span class="keyword">inline</span>  <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">maxContent</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        DATA_TYPE newContent = newMessage.getContent();</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">if</span>(newContent &gt; <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> )</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        {</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> = newContent;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a> = newMessage.getSender();</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment"></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00136"></a><span class="lineno"><a class="line" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">  136</a></span>&#160;    <span class="keyword">inline</span>  <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">minContent</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        DATA_TYPE newContent = newMessage.getContent();</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordflow">if</span>(newContent &lt; <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a>)</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a> = newContent;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a> = newMessage.getSender();</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="classMessage.html#ac5a3cfac4741685e0e8de4351404c024">  150</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMessage.html#ac5a3cfac4741685e0e8de4351404c024">pack</a>(byte * buf)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    {</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="comment">//      *(buf++) = 0; // data message flag</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        memcpy(buf, &amp;<a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a>, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        memcpy(buf, &amp;<a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a>, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        memcpy(buf, &amp;<a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a>, <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE)+1;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classMessage.html#a2bcdde249d2e16e9e7c18e07e1787213">  165</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMessage.html#a2bcdde249d2e16e9e7c18e07e1787213">unpack</a>(byte * buf)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment">//      if(*buf)</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">//          return 0; // first byte should always be zero</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">//      buf++;</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        memcpy(&amp;<a class="code" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a>, buf, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        memcpy(&amp;<a class="code" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a>, buf, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        memcpy(&amp;<a class="code" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a>, buf, <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE)+1;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    }</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;};</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="keyword">typedef</span> <a class="code" href="classMessage.html">Message&lt;double, uint32&gt;</a> <a class="code" href="classMessage.html">DblMessage</a>;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* MESSAGE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classMessage_html_a9f969486b4146319e66d95ebbdbe9dae"><div class="ttname"><a href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">Message::content</a></div><div class="ttdeci">DATA_TYPE content</div><div class="ttdoc">the message body </div><div class="ttdef"><b>Definition:</b> Message.hpp:53</div></div>
<div class="ttc" id="classMessage_html_a8d71332a70b8bd5e8e9c43e9cdd0c92f"><div class="ttname"><a href="classMessage.html#a8d71332a70b8bd5e8e9c43e9cdd0c92f">Message::getRcvr</a></div><div class="ttdeci">ID_TYPE &amp; getRcvr()</div><div class="ttdoc">returns the destination vertex </div><div class="ttdef"><b>Definition:</b> Message.hpp:65</div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdef"><b>Definition:</b> Message.hpp:28</div></div>
<div class="ttc" id="classMessage_html_a436d435e1a8bac5f8e127c3e1f164623"><div class="ttname"><a href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">Message::maxContent</a></div><div class="ttdeci">void maxContent(CMessages &amp;newMessage)</div><div class="ttdoc">copy a new message content if its value is bigger than the current message content ...</div><div class="ttdef"><b>Definition:</b> Message.hpp:123</div></div>
<div class="ttc" id="classMessage_html_af9d795d348683c4b432736e821e76968"><div class="ttname"><a href="classMessage.html#af9d795d348683c4b432736e821e76968">Message::setContent</a></div><div class="ttdeci">void setContent(DATA_TYPE newContent)</div><div class="ttdoc">set the message content </div><div class="ttdef"><b>Definition:</b> Message.hpp:108</div></div>
<div class="ttc" id="classMessage_html_a6356c7503304f26b38f819f64b10fbbb"><div class="ttname"><a href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">Message::minContent</a></div><div class="ttdeci">void minContent(CMessages &amp;newMessage)</div><div class="ttdoc">copy a new message content if its value is smaller than the current message content ...</div><div class="ttdef"><b>Definition:</b> Message.hpp:136</div></div>
<div class="ttc" id="classMessage_html_a607c353c056c6359ab048b7bdb8ec9ba"><div class="ttname"><a href="classMessage.html#a607c353c056c6359ab048b7bdb8ec9ba">Message::Message</a></div><div class="ttdeci">Message(ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</div><div class="ttdoc">constructor of a message with all fields </div><div class="ttdef"><b>Definition:</b> Message.hpp:41</div></div>
<div class="ttc" id="classMessage_html_ad81cd4c7117b9a7fc5fad85cb2466cbf"><div class="ttname"><a href="classMessage.html#ad81cd4c7117b9a7fc5fad85cb2466cbf">Message::sumContent</a></div><div class="ttdeci">void sumContent(DATA_TYPE newContent)</div><div class="ttdoc">sum new content to the current message content </div><div class="ttdef"><b>Definition:</b> Message.hpp:115</div></div>
<div class="ttc" id="classMessage_html_a2bcdde249d2e16e9e7c18e07e1787213"><div class="ttname"><a href="classMessage.html#a2bcdde249d2e16e9e7c18e07e1787213">Message::unpack</a></div><div class="ttdeci">uint32 unpack(byte *buf)</div><div class="ttdoc">unpack a packed message to get the message </div><div class="ttdef"><b>Definition:</b> Message.hpp:165</div></div>
<div class="ttc" id="classMessage_html_ac5a3cfac4741685e0e8de4351404c024"><div class="ttname"><a href="classMessage.html#ac5a3cfac4741685e0e8de4351404c024">Message::pack</a></div><div class="ttdeci">uint32 pack(byte *buf)</div><div class="ttdoc">pack the content of the message to a byte buffer. It is organized as : rcvr, sender, content </div><div class="ttdef"><b>Definition:</b> Message.hpp:150</div></div>
<div class="ttc" id="classMessage_html_a0464788d45c851549e4e483a9cb3723c"><div class="ttname"><a href="classMessage.html#a0464788d45c851549e4e483a9cb3723c">Message::messageSize</a></div><div class="ttdeci">uint32 messageSize()</div><div class="ttdoc">returns the message size in bytes </div><div class="ttdef"><b>Definition:</b> Message.hpp:79</div></div>
<div class="ttc" id="classMessage_html_a38d01ce6162b8e6ecf2dab14f0d72e5b"><div class="ttname"><a href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">Message::sender</a></div><div class="ttdeci">ID_TYPE sender</div><div class="ttdoc">the sender vertex </div><div class="ttdef"><b>Definition:</b> Message.hpp:49</div></div>
<div class="ttc" id="classMessage_html_a38c93c3a1da92bd20e0a8f166c30b6b7"><div class="ttname"><a href="classMessage.html#a38c93c3a1da92bd20e0a8f166c30b6b7">Message::setMessage</a></div><div class="ttdeci">void setMessage(CMessages &amp;newMessage)</div><div class="ttdoc">copy from another message </div><div class="ttdef"><b>Definition:</b> Message.hpp:98</div></div>
<div class="ttc" id="classMessage_html_a73f1bc7e19b3afd684897359f37fc67b"><div class="ttname"><a href="classMessage.html#a73f1bc7e19b3afd684897359f37fc67b">Message::getContent</a></div><div class="ttdeci">DATA_TYPE &amp; getContent()</div><div class="ttdoc">returns the message content </div><div class="ttdef"><b>Definition:</b> Message.hpp:72</div></div>
<div class="ttc" id="classMessage_html_a1e01d44a1fcd11eeeeb2166b8f772708"><div class="ttname"><a href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">Message::rcvr</a></div><div class="ttdeci">ID_TYPE rcvr</div><div class="ttdoc">the receiver vertex </div><div class="ttdef"><b>Definition:</b> Message.hpp:51</div></div>
<div class="ttc" id="classMessage_html_a03cd1893fc75256c319cba7d850f0dcd"><div class="ttname"><a href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">Message::setMessage</a></div><div class="ttdeci">void setMessage(ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</div><div class="ttdoc">preparing the full message fields </div><div class="ttdef"><b>Definition:</b> Message.hpp:87</div></div>
<div class="ttc" id="classMessage_html_ad519d3924cb24505cee555c7893a0faa"><div class="ttname"><a href="classMessage.html#ad519d3924cb24505cee555c7893a0faa">Message::getSender</a></div><div class="ttdeci">ID_TYPE &amp; getSender()</div><div class="ttdoc">returns the sender vertex </div><div class="ttdef"><b>Definition:</b> Message.hpp:58</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
